diff --git a/OAuth.php b/OAuth.php
index 5a3abc8..fa82cf6 100644
--- a/OAuth.php
+++ b/OAuth.php
@@ -186,7 +186,8 @@ class OAuthRequest {/*{{{*/
    */
   public static function from_request($http_method=NULL, $http_url=NULL, $parameters=NULL) {/*{{{*/
     $scheme = (!isset($_SERVER['HTTPS']) || $_SERVER['HTTPS'] != "on") ? 'http' : 'https';
-    @$http_url or $http_url = $scheme . '://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
+    $port = (isset($_SERVER['SERVER_PORT']) && (($scheme == 'http' && $_SERVER['SERVER_PORT'] != 80) || ($scheme == 'https' && $_SERVER['SERVER_PORT'] != 443))) ? ':' . $_SERVER['SERVER_PORT'] : '';
+    @$http_url or $http_url = $scheme . '://' . $_SERVER['HTTP_HOST'] . $port . $_SERVER['REQUEST_URI'];
     @$http_method or $http_method = $_SERVER['REQUEST_METHOD'];
     
     $request_headers = OAuthRequest::get_headers();
